Structure TVertex
  x.f
  y.f
  z.f
EndStructure


OpenWindow(0, 10, 10, 640, 480, "OpenGL demo")
SetWindowColor(0, RGB(200,220,200))
OpenGLGadget(0, 20, 10, WindowWidth(0)-40 , WindowHeight(0)-20)

IncludeFile "MoreFunctions.pbi"
IncludeFile "GLEXT.pbi"

Define vertex_shader.s
Define fragment_shader.s


glMatrixMode_(#GL_PROJECTION)
glLoadIdentity_();
gluPerspective_(45.0, 800/600, 1.0, 60.0)
glMatrixMode_(#GL_MODELVIEW)
glTranslatef_(0, 0, -5)
glShadeModel_(#GL_SMOOTH) 
glEnable_(#GL_DEPTH_TEST)
;glEnable_(#GL_CULL_FACE) 
glColor3f_(1.0, 0.3, 0.0)
glViewport_(0, 0, 800, 600)

Global vbo.i,vao.i
Dim Vertex.TVertex(3)
Vertex(0)\x = 1
Vertex(0)\y = -1
Vertex(0)\z = 0

Vertex(1)\x = -1
Vertex(1)\y = -1
Vertex(1)\z = 0

Vertex(2)\x = 1
Vertex(2)\y = 1
Vertex(2)\z = 0

Vertex(3)\x = -1
Vertex(3)\y = 1
Vertex(3)\z = 0
;=================================================================================
;=================================================================================
Dim index.l(5)
index(0) = 1 
index(1) = 0
index(2) = 2
index(3) = 3
index(4) = 1
index(5) = 2

;indexsize = 6 ;#GL_UNSIGNED_BYTE
indexsize = 6*2 ;#GL_UNSIGNED_SHORT
indexsize = 6*4 ;#GL_UNSIGNED_INT

glGenBuffers( 1, @vbo ) ; Vertex Buffer Object
glBindBuffer(#GL_ARRAY_BUFFER, vbo )
glBufferData(#GL_ARRAY_BUFFER,SizeOf(TVertex)*4,@Vertex(0), #GL_STATIC_DRAW)
glBindBuffer(#GL_ARRAY_BUFFER,0);
glGenBuffers( 1, @vao );  Vertex Attribute Object
glBindBuffer(#GL_ELEMENT_ARRAY_BUFFER, vao);
glBufferData(#GL_ELEMENT_ARRAY_BUFFER, indexsize,@index(0),#GL_STATIC_DRAW);
glBindBuffer(#GL_ELEMENT_ARRAY_BUFFER, 0);
rot.f = 1

Repeat
  glViewport_(0, 0, WindowWidth(0), WindowHeight(0))
  glClearColor_(0.2, 0.9, 0.2, 1)
  glClear_(#GL_COLOR_BUFFER_BIT | #GL_DEPTH_BUFFER_BIT)
  glEnableClientState_(#GL_VERTEX_ARRAY )
  glRotatef_(rot, 0, 1, 0);
  glBindBuffer(#GL_ARRAY_BUFFER, vbo)
  glVertexPointer_(3, #GL_FLOAT,0,0)
    
  glBindBuffer(#GL_ELEMENT_ARRAY_BUFFER, vao)
  glDrawElements_(#GL_TRIANGLES,indexsize,#GL_UNSIGNED_INT,0)
  glBindBuffer(#GL_ELEMENT_ARRAY_BUFFER, 0);
  glBindBuffer(#GL_ARRAY_BUFFER,0);
  glDisableClientState_(#GL_VERTEX_ARRAY);

  ;SwapBuffers_(hdc)
  ;Delay(16)
  SetGadgetAttribute(0, #PB_OpenGL_FlipBuffers, #True)
Until WindowEvent() = #PB_Event_CloseWindow
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 88
; EnableXP